﻿package{
	import flash.display.*;
	import flash.events.Event;
	import flash.filters.BlurFilter;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.ui.Mouse;
    import flash.media.Microphone;
    import flash.system.Security;
    import flash.system.SecurityPanel;
	
	public class Perliner extends Sprite
	{
		
		private var bmd:BitmapData;
		private var background:Bitmap;
		private var angle:Number = 0;
		private var painter:Sprite;
		private var matrix:Matrix ;
		private var color:uint = 0xffffff;
		private var filterObj:BlurFilter = new BlurFilter(1,1.04,1.02);
		var myMic:Microphone = Microphone.getMicrophone();
		Security.showSettings(SecurityPanel.MICROPHONE);
		
		public function Perliner():void
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		
		private function addedHandler(e:Event):void
		{
			Mouse.hide();
			bmd = new BitmapData(stage.stageWidth,stage.stageHeight,false,0x000000);
			background = new Bitmap(bmd);
			addChild(background);
			painter = new Sprite();
			init();
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		
		private function init():void
		{
			myMic.setLoopBack(true);
			myMic.setUseEchoSuppression(true);
			var sounder:Number = myMic.activityLevel*15;
			angle = 0;
			color = Math.random()*0xff0000;
			painter.graphics.lineStyle(1,color);
			painter.graphics.lineTo(0,sounder);

		}
		private function enterHandler(e:Event):void
		{
			myMic.setLoopBack(true);
			myMic.setUseEchoSuppression(true);
			var sounder:Number = myMic.activityLevel*6;

			if(angle<800){
				matrix = new Matrix(sounder/15,1,1,1,stage.width/2,-2);
				matrix.translate(angle,0);
				matrix.rotate(angle);				
				bmd.applyFilter(bmd,bmd.rect,new Point(0,0),filterObj);
				bmd.draw(painter,matrix);
				angle++;
			}else{
				init();
			}
		}
	}
}